<!--
“Copyright 2020 L'esfera”

This file is part of L'esfera.

L'esfera is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
-->

<template>
  <div id="node">
    <div class="container">
        <div class="row">
            <div class="col-md-6">
                <NodeDetails @editNode="editNode" :current_node="current_node" />
                <NodeEditor @updateNode="updateNode" :node_data="editor_data" />
            </div>

            <div class="col-md-6">
                <h2 style="margin-bottom: 0.5em">té relació amb..</h2>
                <LinkList
                    :current_node="current_node"
                    @fetchNode="fetchNode"
                />
            </div>    
        </div>  
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import { eventBus } from '@/main.js';
import NodeDetails from '@/components/node-details/NodeDetails.vue'
import LinkList from '@/components/link-list/LinkList.vue'
import NodeEditor from '@/components/node-editor/NodeEditor.vue'

export default {
    name: 'Node',
    components: {
        NodeDetails,
        LinkList,
        NodeEditor
    },
    data() {
        return {
            current_node: {},
            editor_data: {}
        }
    },
    created () {
        eventBus.$on('createNode', name => {
            this.editor_data = {}
            this.editor_data.name = name
            this.editor_data.current_node_id = this.current_node_id
            this.$root.$emit('bv::show::modal', 'node-editor')
        });
        this.$watch(
            () => this.$route.params,
            (toParams) => {
                this.fetchNode(toParams.node_id)
            }
        )
    },
    mounted () {
        this.fetchNode(this.$route.params.node_id)
    },
    computed: {
        current_node_id: function () {
            //console.log("compute node_id" + this.current_node.id)
            return this.current_node.id
        },
    },
    methods: {
        fetchNode: function (node_id) {
            axios
            .get(process.env.VUE_APP_API_SERVER + '/nodes/'+node_id)
            .then(response => ( this.current_node = response.data,
                                document.title = response.data.name))
        },
        editNode: function () {
            this.editor_data = Object.assign({}, this.current_node);
            this.$root.$emit('bv::show::modal', 'node-editor')
        },
        updateNode: function (node) {
            this.current_node = node
        }
    }
}
</script>

<style>

</style>
